<template>
  <div v-if="auth">
    <div
      v-if="actionManager.profileSidebarShow"
      class="kit shadowSidebar"
      @click.prevent="hideProfileSidebar"/>

    <aside
      id="siteProfileSidebar"
      class="kit profile sidebar"
      :class="{ active: actionManager.profileSidebarShow}">
      <i
        class="icon link close"
        @click.prevent="hideProfileSidebar"/>
      <div class="heading">
        <div
          class="avatar"
          :class="{ organization: auth.isOrganization }"/>
        <div class="profile name">
          <template v-if="!auth.isOrganization">
            <template v-if="auth.userProfile">
              {{ auth.userProfile.firstName }}
            </template>
          </template>
          <template v-else>
            <template v-if="auth.organization.legalName">
              {{ auth.organization.legalName }}
            </template>
            <template v-else-if="auth.organization.legals.length">
              {{ auth.organization.legals[0].name }}
            </template>
          </template>
        </div>
        <flink
          href="/cabinet/wrench/profile"
          domain="main"
          class="profile login">{{ auth.displayedName }}</flink>
      </div>

      <nav class="profile navigation">

        <flink
          href="/cabinet/wrench/profile"
          domain="main"
          class="item my-profile bold group-end">
          <span class="icon">
            <img
              svg-inline
              src="~/assets/svg/icons/i-profile-my.svg">
          </span>
          <span class="text">Мой профиль</span>
        </flink>
        <flink
          href="/cabinet/wrench/notification-setup"
          domain="main"
          class="item notifications-settings mobilshow">
          <span class="icon">
            <img
              svg-inline
              src="~/assets/svg/icons/i-profile-notification.svg">
          </span>
          <span class="text">Настройка уведомлений</span>
        </flink>

        <ProfileLinks/>

        <span
          @click="exit"
          class="item log-out bold">
          <span class="text">Выход</span>
        </span>
      </nav>

      <div
        class="description"
        v-if="auth.isOrganization">
        <div>
          Разделы
          <nobr>«Мои запчасти»</nobr>
          и
          <nobr>«Загрузка прайсов»</nobr>
          доступны в полной версии
          <flink
            href="/"
            domain="main">gisauto.ru
          </flink>
        </div>
      </div>
    </aside>
  </div>
</template>

<script>
import { mapState, createNamespacedHelpers } from 'vuex';
import { HIDE_PROFILE_SIDEBAR } from '~/assets/js/store/actionManager/mutation-types';
import { LOGOUT } from '~/assets/js/store/user/action-types';
import ProfileLinks from '~/components/layout/profileLinks';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'ProfileSidebar',
  components: {
    ProfileLinks,
  },
  props: {
    isIndex: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      msg: '',
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    ...mapState(['actionManager']),
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      hideProfileSidebar: HIDE_PROFILE_SIDEBAR,
    }),
    ...STORE_USER.mapActions({
      logout: LOGOUT,
    }),
    exit() {
      if (this.auth !== null) {
        this.hideProfileSidebar();
        this.logout();
      }
    },
  },
};
</script>

<style lang="scss" scoped>
  @import "~/assets/scss/modules/_profile-sidebar.scss";

  .kit.profile.sidebar {
  position: fixed;
  top: 0;
  right: -15rem;
  bottom: 0;
  height: 100vh;
  width: 15rem;
  z-index: 1750;
  font-size: 13px;
  color: #4a4a4a;
  font-weight: normal;
  line-height: normal;
  background-color: #fff;
  box-shadow: 0 24px 32px rgba(60, 2, 16, 0.08);
  overflow: auto;
  transition: right 0s ease;
  @media only screen and (max-width: 1024px) {
    display: none;
    width: 100%;
    z-index: 1;
    color: #8798a4;
    font-size: 1rem;
    padding: 2.625em 0 0;
    flex-flow: column nowrap;
    box-shadow: 0 0 2rem rgba(0,0,0,.15);
    overflow: hidden;
    left: 0;
  }
  &.active{
    right: 0;
    @media only screen and (max-width: 1024px) {
      display: flex;
      left: 0;
      top: 0;
    }
  }
  .icon.close {
    position: absolute;
    right: 1rem;
    top: 1rem;
    font-size: 0;
    width: 1.5rem;
    height: 1.5rem;
    background-repeat: no-repeat;
    background-position: center;
    background-size: auto;
    background-image: url("~assets/svg/icons/i-close.svg");
  }
  .heading {
    background-color: #dbe4e9;
    display: block;
    text-align: center;
    min-height: 208px;
    padding: 2.5rem 1rem 1.25rem;
    @media only screen and (max-width: 1024px) {
      display: none;
    }
    .avatar {
      box-shadow: 0 7px 20px 0 rgba(40, 50, 56, 0.15);
      height: 6rem;
      width: 6rem;
      border-radius: 50%;
      margin: 0 auto .8rem;
      border: 1px solid #fff;
      @include inline-svg-icon('profile-sidebar-avatar', #ccc, center, 100%);
      background-size: cover;
      display: flex;
      justify-content: center;
      align-items: center;
      &.organization {
        @include inline-svg-icon('profile-sidebar-avatar-organization', #ccc, center, 100%);
      }
    }
    .profile.login {
      color: #558fcc;
      text-decoration: none;
      margin-top: 0.3125rem;
      display: block;
      &:hover {
        text-decoration: underline;
      }
    }
    .profile.name {
      font-weight: 700;
    }
  }
  .description {
    font-size: 0.8125rem;
    padding: 1em 1em 1em 5.4em;
    flex-grow: 1;
    background: #fff;
    display: none;
    @media only screen and (max-width: 1024px) {
      display: flex;
    }
  }
  .profile.navigation {
    display: flex;
    flex-flow: column nowrap;
    padding: 2rem;
    @media only screen and (max-width: 1024px) {
      padding: 0;
      background: #fff;
    }
  }
}
.kit.shadowSidebar {
  z-index: 20;
  position: fixed;
  width: 100vw;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background-color: rgba(0, 0, 0, 0.25);
  transition: 0.3s ease all;
  @media only screen and (max-width: 1024px) {
    display: none;
  }
}
</style>
